/*****************************************************************************
*               interfacekitconf.h
*
*  This header file contains all constants and types required to run on a
*  BeOS Display system.  This also uses the UNIX config file unixconf.h
*  for the non-display portions of the UNIX code.
*****************************************************************************/

#ifndef _INTERFACEKITCONF_H_
#define _INTERFACEKITCONF_H_

/* Below are several defines needed by the X Windows part of POV.  You
 * may redefine them as needed in this config.h file.  Each has a default
 * which will be defined in frame.h if you don't define it here.
 */

#include "unixconf.h"

/*
 * These handle the parsing of the usual BeOS command-line args.
 */
#define STARTUP_POVRAY    BEOS_init_povray(&argc, &argv);
#define FINISH_POVRAY(i)  BEOS_finish_povray(i);
#ifdef  __cplusplus
 extern "C" {
#endif
void BEOS_init_povray PARAMS((int *argc, char **argv[]));
void BEOS_finish_povray PARAMS((int status));
#ifdef  __cplusplus
}
#endif

/*
 * These are the X Windows display routines.
 */
#define POV_DISPLAY_INIT(w,h) BEOS_display_init(w,h)
#define POV_DISPLAY_PLOT(x,y,r,g,b,a) BEOS_display_plot(x,y,r,g,b,a)
#define POV_DISPLAY_PLOT_RECT(x1,y1,x2,y2,r,g,b,a) BEOS_display_plot_rect(x1,y1,x2,y2,r,g,b,a)
#define POV_DISPLAY_PLOT_BOX(x1,y1,x2,y2,r,g,b,a) BEOS_display_plot_box(x1,y1,x2,y2,r,g,b,a)
#define POV_DISPLAY_FINISHED  BEOS_display_finished();
#define POV_DISPLAY_CLOSE BEOS_display_close();

#ifdef  __cplusplus
 extern "C" {
#endif

void BEOS_display_init PARAMS((int w, int h));
void BEOS_display_plot PARAMS((int x, int y,
                               unsigned char Red, unsigned char Green,
                               unsigned char Blue, unsigned char Alpha));
void BEOS_display_plot_rect PARAMS((int x1, int y1, int x2, int y2,
                                    unsigned char Red, unsigned char Green,
                                    unsigned char Blue, unsigned char Alpha));
void BEOS_display_plot_box PARAMS((int x1, int y1, int x2, int y2,
                                    unsigned char Red, unsigned char Green,
                                    unsigned char Blue, unsigned char Alpha));
void BEOS_display_finished PARAMS((void));
void BEOS_display_close PARAMS((void));

#ifdef  __cplusplus
}
#endif

/*
 * This is the render abort function for X Windows.  It is not needed for
 * the command-line interface, since the abort is handled via interrupts.
 */
#define TEST_ABORT Stop_Flag += BEOS_Test_Abort();
#ifdef  __cplusplus
 extern "C" {
#endif
int BEOS_Test_Abort PARAMS((void));
#ifdef  __cplusplus
}
#endif

#endif // _INTERFACEKITCONF_H_